Index: /trunk/kernel/fs/vfs.h
===================================================================
--- /trunk/kernel/fs/vfs.h	(revision 656)
+++ /trunk/kernel/fs/vfs.h	(revision 657)
@@ -929,66 +899,69 @@
  * @ return 0 if success / return -1 if device access failure.
  *****************************************************************************************/
-error_t vfs_fs_add_dentry( vfs_inode_t  * parent,
-                           vfs_dentry_t * dentry );
-
-/******************************************************************************************
- * This function updates the mapper associated to a directory inode identified by the 
- * <parent> argument, to remove an entry identified by the <dentry> argument. 
- * The directory inode descriptor and the dentry descriptor are in the same cluster.
+error_t vfs_fs_add_dentry( xptr_t         parent_inode_xp,
+                           vfs_dentry_t * dentry_ptr );
+
+/******************************************************************************************
+ * This function removes from a directory mapper identified by the <parent_inode_xp> 
+ * argument, an entry identified by the <dentry_ptr> argument. 
  * Depending on the file system type, it calls the proper, FS specific function.
  * Finally, it synchronously updates the parent directory on IOC device.
- *
- * Depending on the file system type, it calls the relevant, FS specific function.
- * It must be executed by a thread running in the cluster containing the parent directory.
- * It can be the RPC_VFS_FS_REMOVE_DENTRY. This function does NOT take any lock.
- ******************************************************************************************
- * @ parent  : local pointer on parent (directory) inode.
- * @ dentry  : local pointer on dentry containing name.
+ * This function can be called by any thread running in any cluster.
+ ******************************************************************************************
+ * @ parent_inode_xp  : extended pointer on parent (directory) inode.
+ * @ dentry_ptr       : local pointer on dentry containing name.
  * @ return 0 if success / return -1 if device access failure.
  *****************************************************************************************/
-error_t vfs_fs_remove_dentry( vfs_inode_t  * parent,
-                              vfs_dentry_t * dentry );
-
-/******************************************************************************************
- * This function scan the mapper of an an existing parent inode directory, identified by
- * the <parent> argument to find a directory entry identified by the <name> argument,
- * and updates both the child inode descriptor, identified by the <child_xp> argument,
- * and the associated dentry descriptor :
+error_t vfs_fs_remove_dentry( xptr_t         parent_inode_xp,
+                              vfs_dentry_t * dentry_ptr );
+
+/******************************************************************************************
+ * This function scan a directory mapper, identified by the <parent_inode_xp> argument
+ * to find a directory entry identified by the <dentry_ptr> argument,
+ * and updates both the child inode descriptor, and the associated dentry descriptor:
  * - It set the "size", "type", and "extend" fields in inode descriptor.
  * - It set the "extend" field in dentry descriptor.
- * It is called by the vfs_lookup() function in case of miss.
- *
+ * It is called by the vfs_lookup() function in case of miss, and does NOT take any lock.
  * Depending on the file system type, it calls the relevant, FS specific function.
- * It must be called by a thread running in the cluster containing the parent inode.
- * It can be the RPC_VFS_FS_NEW_DENTRY. This function does NOT take any lock.
- ******************************************************************************************
- * @ parent    : local pointer on parent inode (directory).
- * @ name      : child name.
- * @ child_xp  : extended pointer on remote child inode (file or directory)
+ * This function can be called by any thread running in any cluster.
+ ******************************************************************************************
+ * @ parent_inode_xp  : extended pointer on parent inode (directory).
+ * @ dentry_ptr       : local pointer on new entry (in parent inode cluster).
  * @ return 0 if success / return -1 if dentry not found.
  *****************************************************************************************/
-error_t vfs_fs_new_dentry( vfs_inode_t * parent,
-                           char        * name,
-                           xptr_t        child_xp );
-
-/******************************************************************************************
- * This function scan the mapper of an an existing inode directory, identified by
- * the <inode> argument, to find a directory entry identified by the <dentry> argument,
- * and update the size for this directory entry in mapper, as defined by <size>.
+error_t vfs_fs_new_dentry_from_mapper( xptr_t         parent_inode_xp,
+                                       vfs_dentry_t * dentry_ptr );
+
+/*****************************************************************************************
+ * This function  introduces a brand new dentry identified by the <dentry_ptr> argument
+ * in the mapper of a directory identified by the <parent_inode_xp> argument.
+ * It is called by the vfs_lookup() function, and does NOT take any lock.
+ * The child inode descriptor, and the dentry descriptor must have been previously
+ * allocated and introduced in the Inode Tree. The dentry descriptor contains the name. 
+ * Depending on the file system type, it calls the relevant, FS specific function.
+ * This function can be called by any thread running in any cluster.
+ *****************************************************************************************
+ * @ parent_inode_xp : [in]  extended pointer on parent inode (directory).
+ * @ dentry_ptr      : [in]  local pointer on dentry (in parent inode cluster).
+ * @ return 0 if success / return -1 if failure.
+ ****************************************************************************************/
+error_t vfs_fs_new_dentry_to_mapper( xptr_t         parent_inode_xp,
+                                     vfs_dentry_t * dentry_ptr );
+
+/******************************************************************************************
+ * This function updates the "size" field of a directory entry identified by the 
+ * <dentry_ptr> argument in a directory mapper identified by the <parent_inode_xp>
+ * from the value contained in the inode descriptor.
  * The parent directory on device is synchronously updated.
  * It is called by the vfs_close() function.
- *
  * Depending on the file system type, it calls the relevant, FS specific function.
- * It must be called by a thread running in the cluster containing the parent inode.
- * It can be the RPC_VFS_FS_UPDATE_DENTRY. This function does NOT take any lock.
- ******************************************************************************************
- * @ parent    : local pointer on parent inode (directory).
- * @ dentry    : local pointer on dentry.
- * @ size      : new size value (bytes).
- * @ return 0 if success / return ENOENT if not found.
- *****************************************************************************************/
-error_t vfs_fs_update_dentry( vfs_inode_t  * inode,
-                              vfs_dentry_t * dentry,
-                              uint32_t       size );
+ * This function can be called by any thread running in any cluster.
+ ******************************************************************************************
+ * @ parent_inode_xp  : local pointer on parent inode (directory).
+ * @ dentry_ptr       : local pointer on dentry (in parent directory cluster).
+ * @ return 0 if success / return -1 if not found.
+ *****************************************************************************************/
+error_t vfs_fs_update_dentry( xptr_t         parent_inode_xp,
+                              vfs_dentry_t * dentry_ptr );
 
 /******************************************************************************************
@@ -1002,8 +975,9 @@
  * the Inode Tree is dynamically created, and all dirent fiels are documented in the
  * dirent array. Otherwise, only the dentry name is documented.
- *
+ * This function does NOT take any lock.
  * Depending on the file system type, it calls the relevant, FS specific function.
- * It must be called by a thread running in the cluster containing the parent inode.
- * This function does NOT take any lock.
+ *
+ * WARNING : this function must be called by a thread running in the cluster containing
+ * the target directory inode.
  ******************************************************************************************
  * @ inode      : [in]  local pointer on directory inode.
@@ -1031,12 +1005,11 @@
  * directory are synchronously done on the IOC device by the two vfs_fs_add_dentry() 
  * and vfs_fs_remove_dentry() functions.
- *
  * Depending on the file system type, it calls the relevant, FS specific function.
- * It must be called by a thread running in the inode cluster.
+ * This function can be called by any thread running in any cluster.
  *****************************************************************************************
- * @ inode   : local pointer on inode.
- * @ return 0 if success / return EIO if failure during device access. 
+ * @ inode_xp   : remote pointer on inode.
+ * @ return 0 if success / return -1 if failure. 
  ****************************************************************************************/
-error_t vfs_fs_sync_inode( struct vfs_inode_s * inode );
+error_t vfs_fs_sync_inode( xptr_t inode_xp );
 
 /*****************************************************************************************
@@ -1044,5 +1017,4 @@
  * for the FAT itself. It scan all clusters registered in the FAT mapper, and copies 
  * to device each page marked as dirty.
- *
  * Depending on the file system type, it calls the relevant, FS specific function.
  * It can be called by a thread running in any cluster.
@@ -1053,30 +1025,4 @@
 error_t vfs_fs_sync_fat( vfs_fs_type_t fs_type );
 
-/*****************************************************************************************
- * This function updates the free clusters info on the IOC device for the FS defined
- * by the <fs_type> argument. 
- *
- * Depending on the file system type, it calls the relevant, FS specific function.
- * It can be called by a thread running in any cluster.
- *****************************************************************************************
- * @ fs_type   : specific file system type.
- * @ return 0 if success / return EIO if failure during device access.
- ****************************************************************************************/
-error_t vfs_fs_sync_free_info( vfs_fs_type_t fs_type );
-
-/******************************************************************************************
- * This function allocates a free cluster from the FS identified by the <fs_type>
- * argument. It updates the selected FS File Allocation Table.
- *
- * Depending on the file system type, it calls the relevant, FS specific function.
- * It can be called by a thread running in any cluster.
- ******************************************************************************************
- * @ fs_type   : [in]  File System type.
- * @ cluster   : [out] cluster index in File system.
- * @ return 0 if success / return -1 if no free cluster
- *****************************************************************************************/
-error_t vfs_fs_cluster_alloc( uint32_t   fs_type,
-                              uint32_t * cluster );
-
 /******************************************************************************************
  * This function makes all I/O operations required to release all clusters allocated
@@ -1084,6 +1030,7 @@
  * Depending on the file system type, it calls the proper, FS specific function.
  * It is called by the vfs_unlink() function.
- * It can be executed by a thread running in any cluster.
  * This function does NOT take any lock.
+ * Depending on the file system type, it calls the relevant, FS specific function.
+ * This function can be executed by any thread running in any cluster.
  ******************************************************************************************
  * @ inode_xp  : extended pointer on inode.
@@ -1092,4 +1039,21 @@
 error_t vfs_fs_release_inode( xptr_t  inode_xp ); 
 
+/******************************************************************************************
+ * This function makes the I/O operation to move one page identified by the <page_xp>
+ * argument to/from the IOC device from/to the mapper, as defined by the <cmd_type>.
+ * It is used in case of MISS on the mapper (read), or when a dirty page in the mapper
+ * must be updated in the File System (write).
+ * The mapper pointer, and the page index in file are obtained from the page descriptor.
+ * This function does NOT take any lock.
+ * Depending on the file system type, it calls the proper, FS specific function.
+ * This function can be executed by any thread running in any cluster.
+ ******************************************************************************************
+ * @ page_xp   : extended pointer on page descriptor (for mapper and page_id).
+ * @ cmd_type  : IOC_READ / IOC_WRITE / IOC_SYNC_READ / IOC_SYNC_WRITE
+ * @ returns 0 if success / return -1 if device access failure.
+ *****************************************************************************************/
+error_t vfs_fs_move_page( xptr_t          page_xp,
+                          ioc_cmd_type_t  cmd_type );
+
 
 #endif	/* _VFS_H_ */
Index: /trunk/kernel/kern/chdev.c
===================================================================
--- /trunk/kernel/kern/chdev.c	(revision 656)
+++ /trunk/kernel/kern/chdev.c	(revision 657)
@@ -1,6 +1,6 @@
 /*
- * chdev.c - channel device descriptor operations implementation.
+ * chdev.c - channel device API implementation.
  *
- * Authors  Alain Greiner   (2016)
+ * Authors  Alain Greiner   (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -148,5 +148,6 @@
 #endif
 
-    thread_t * this = CURRENT_THREAD;
+    thread_t * this      = CURRENT_THREAD;
+    xptr_t     client_xp = XPTR( local_cxy , this );
 
     // get chdev cluster and local pointer
@@ -197,7 +198,7 @@
     lock_xp            = XPTR( chdev_cxy , &chdev_ptr->wait_lock );
 
-    // The following actions execute in critical section,
-    // because the lock_acquire / lock_release : 
-    // (1) take the lock protecting the chdev state
+    // The following actions are executed in critical section,
+    // (because the busylock_acquire / busylock_release) 
+    // (1) take the lock protecting the waiting queue
     // (2) register client thread in server queue 
     // (3) unblock the server thread and block client thread
@@ -224,6 +225,6 @@
  
     // 3. client thread unblocks server thread and blocks itself
-    thread_unblock( server_xp , THREAD_BLOCKED_IDLE );
-    thread_block( XPTR( local_cxy , CURRENT_THREAD ) , THREAD_BLOCKED_IO );
+    thread_unblock( server_xp , THREAD_BLOCKED_CLIENT );
+    thread_block( client_xp , THREAD_BLOCKED_IO );
 
 #if (DEBUG_CHDEV_CMD_TX & 1)
@@ -300,8 +301,6 @@
     server = CURRENT_THREAD;
 
-    // build extended pointer on root of client threads queue
+    // build extended pointer on root & lock of client threads queue
     root_xp = XPTR( local_cxy , &chdev->wait_root );
-
-    // build extended pointer on lock protecting client threads queue
     lock_xp = XPTR( local_cxy , &chdev->wait_lock );
 
@@ -351,5 +350,5 @@
 #endif
             // block 
-            thread_block( XPTR( local_cxy , server ) , THREAD_BLOCKED_IDLE ); 
+            thread_block( XPTR( local_cxy , server ) , THREAD_BLOCKED_CLIENT ); 
 
             // deschedule
@@ -358,13 +357,14 @@
         else                            // waiting queue not empty
         {
+            // get pointers on first client thread
+            client_xp  = XLIST_FIRST( root_xp , thread_t , wait_list );
+            client_cxy = GET_CXY( client_xp );
+            client_ptr = GET_PTR( client_xp );
+
+            // remove this client thread from chdev waiting queue
+            xlist_unlink( XPTR( client_cxy , &client_ptr->wait_list ) );
+
             // release lock protecting the waiting queue
             remote_busylock_release( lock_xp );
-
-            // get extended pointer on first client thread
-            client_xp = XLIST_FIRST( root_xp , thread_t , wait_list );
-
-            // get client thread cluster and local pointer
-            client_cxy = GET_CXY( client_xp );
-            client_ptr = GET_PTR( client_xp );
 
 #if( DEBUG_CHDEV_SERVER_TX || DEBUG_CHDEV_SERVER_RX )
@@ -402,13 +402,4 @@
             // unblock client thread when driver returns
             thread_unblock( client_xp , THREAD_BLOCKED_IO );
-
-            // get the lock protecting the waiting queue
-            remote_busylock_acquire( lock_xp );
-
-            // remove this client thread from chdev waiting queue
-            xlist_unlink( XPTR( client_cxy , &client_ptr->wait_list ) );
-
-            // release lock protecting the waiting queue
-            remote_busylock_release( lock_xp );
 
 #if DEBUG_CHDEV_SERVER_RX
